Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.util.processor
Class VersionedPut

`java.lang.Object
com.tangosol.util.Base
com.tangosol.util.processor.AbstractProcessor
com.tangosol.util.processor.VersionedPut`

All Implemented Interfaces:
  ExternalizableLite, PortableObject, InvocableMap.EntryProcessor, java.io.Serializable

      public class VersionedPut

extends AbstractProcessor
implements ExternalizableLite, PortableObject

VersionedPut is an EntryProcessor that assumes that entry values implement `Versionable` interface and performs an `Entry.setValue` operation if and only if the version of the specified value matches to the version of the current value. In case of the match, the VersionedPut will increment the version indicator before the value is updated.

Since:
  Coherence 3.2
Author:
  gg 2006.05.07; Acknowledgments: Simon Bisson
See Also:
  `ConditionalPut`

Field Summary
`protected boolean` | `m_fInsert` Specifies whether or not an insert is allowed.
`protected boolean` | `m_fReturn` Specifies whether or not a return value is required.
`protected Versionable` | `m_oValue` Specifies the new value to update an entry with.

Constructor Summary
`VersionedPut()` Default constructor (necessary for the ExternalizableLite interface).
`VersionedPut(Versionable oValue)` Construct a VersionedPut that updates an entry with a new value if and only if the version of the new value matches to the version of the current entry's value (which must exist).
`VersionedPut(Versionable oValue, boolean fAllowInsert, boolean fReturn)` Construct a VersionedPut that updates an entry with a new value if and only if the version of the new value matches to the version of the current entry's value.

Method Summary
`boolean` | `equals(java.lang.Object o)` Compare the VersionedPut with another object to determine equality.
`int` | `hashCode()` Determine a hash value for the VersionedPut object according to the general `Object.hashCode()` contract.
`java.lang.Object` | `process(InvocableMap.Entry entry)` Process a Map.Entry object.
`java.util.Map` | `processAll(java.util.Set setEntries)` Process a Set of InvocableMap.Entry objects. This method is semantically equivalent to:
       Map mapResults = new ListMap();
       for (Iterator iter = setEntries.iterator(); iter.hasNext(); )
           {
           Entry entry = (Entry) iter.next();
           mapResults.put(entry.getKey(), process(entry));
           }
       return mapResults;
Note: if processAll() call throws an exception, entries that were removed from the setEntries would be considered successfully processed and corresponding changes will be made to the underlying Map.
`protected java.lang.Object` | `processEntry(InvocableMap.Entry entry, Versionable oValueNew, boolean fInsert, boolean fReturn)` Process the given entry.
`void` | `readExternal(java.io.DataInput in)` Restore the contents of this object by loading the object's state from the passed DataInput object.
`void` | `readExternal(PofReader in)` Restore the contents of a user type instance by reading its state using the specified PofReader object.
`java.lang.String` | `toString()` Return a human-readable description for this VersionedPut.
`void` | `writeExternal(java.io.DataOutput out)` Save the contents of this object by storing the object's state into the passed DataOutput object.
`void` | `writeExternal(PofWriter out)` Save the contents of a POF user type instance by writing its state using the specified PofWriter object.

Field Detail

### m_oValue

    protected Versionable m_oValue

  Specifies the new value to update an entry with.

### m_fInsert

    protected boolean m_fInsert

  Specifies whether or not an insert is allowed.

### m_fReturn

    protected boolean m_fReturn

  Specifies whether or not a return value is required.

Constructor Detail

### VersionedPut

    public VersionedPut()

  Default constructor (necessary for the ExternalizableLite interface).

### VersionedPut

    public VersionedPut(Versionable oValue)

  Construct a VersionedPut that updates an entry with a new value if and only if the version of the new value matches to the version of the current entry's value (which must exist). The result of the `process(com.tangosol.util.InvocableMap.Entry)` invocation does not return any result.
  Parameters:
    `oValue` - a Versionable value to update an entry with

### VersionedPut

    public VersionedPut(Versionable oValue,
                        boolean fAllowInsert,
                        boolean fReturn)

  Construct a VersionedPut that updates an entry with a new value if and only if the version of the new value matches to the version of the current entry's value. This processor optionally returns the current value as a result of the invocation if it has not been updated (the versions did not match).
  Parameters:
    `oValue` - a value to update an entry with
    `fAllowInsert` - specifies whether or not an insert should be allowed (no currently existing value)
    `fReturn` - specifies whether or not the processor should return the current value in case it has not been updated

Method Detail

### process

    public java.lang.Object process(InvocableMap.Entry entry)

  Process a Map.Entry object.
  Specified by:
    `process` in interface `InvocableMap.EntryProcessor`
  Parameters:
    `entry` - the Entry to process
  Returns:
    the result of the processing, if any

### processAll

    public java.util.Map processAll(java.util.Set setEntries)

  Process a Set of InvocableMap.Entry objects. This method is semantically equivalent to:

         Map mapResults = new ListMap();
         for (Iterator iter = setEntries.iterator(); iter.hasNext(); )
             {
             Entry entry = (Entry) iter.next();
             mapResults.put(entry.getKey(), process(entry));
             }
         return mapResults;

  Note: if processAll() call throws an exception, entries that were removed from the setEntries would be considered successfully processed and corresponding changes will be made to the underlying Map.
  Specified by:
    `processAll` in interface `InvocableMap.EntryProcessor`
  Overrides:
    `processAll` in class `AbstractProcessor`
  Parameters:
    `setEntries` - a Set of InvocableMap.Entry objects to process
  Returns:
    a Map containing the results of the processing, up to one entry for each InvocableMap.Entry that was processed, keyed by the keys of the Map that were processed, with a corresponding value being the result of the processing for each key

### equals

    public boolean equals(java.lang.Object o)

  Compare the VersionedPut with another object to determine equality.
  Returns:
    true iff this VersionedPut and the passed object are equivalent VersionedPut

### hashCode

    public int hashCode()

  Determine a hash value for the VersionedPut object according to the general `Object.hashCode()` contract.
  Returns:
    an integer hash value for this VersionedPut object

### toString

    public java.lang.String toString()

  Return a human-readable description for this VersionedPut.
  Returns:
    a String description of the VersionedPut

### readExternal

    public void readExternal(java.io.DataInput in)
                      throws java.io.IOException

  Restore the contents of this object by loading the object's state from the passed DataInput object.
  Specified by:
    `readExternal` in interface `ExternalizableLite`
  Parameters:
    `in` - the DataInput stream to read data from in order to restore the state of this object
  Throws:
    `java.io.IOException` - if an I/O exception occurs
    `java.io.NotActiveException` - if the object is not in its initial state, and therefore cannot be deserialized into

### writeExternal

    public void writeExternal(java.io.DataOutput out)
                       throws java.io.IOException

  Save the contents of this object by storing the object's state into the passed DataOutput object.
  Specified by:
    `writeExternal` in interface `ExternalizableLite`
  Parameters:
    `out` - the DataOutput stream to write the state of this object to
  Throws:
    `java.io.IOException` - if an I/O exception occurs

### readExternal

    public void readExternal(PofReader in)
                      throws java.io.IOException

  Restore the contents of a user type instance by reading its state using the specified PofReader object.
  Specified by:
    `readExternal` in interface `PortableObject`
  Parameters:
    `in` - the PofReader from which to read the object's state
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeExternal

    public void writeExternal(PofWriter out)
                       throws java.io.IOException

  Save the contents of a POF user type instance by writing its state using the specified PofWriter object.
  Specified by:
    `writeExternal` in interface `PortableObject`
  Parameters:
    `out` - the PofWriter to which to write the object's state
  Throws:
    `java.io.IOException` - if an I/O error occurs

### processEntry

    protected java.lang.Object processEntry(InvocableMap.Entry entry,
                                            Versionable oValueNew,
                                            boolean fInsert,
                                            boolean fReturn)

  Process the given entry.
  Parameters:
    `entry` - entry the entry to be processed
    `oValueNew` - the new value
    `fInsert` - specifies whether or not an insert is allowed
    `fReturn` - specifies whether or not a return value is required
  Returns:
    the result of processing the entry; can be NO_RESULT

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.